searchNodes=[{"doc":"Convenience functions to work with APIac and API requests","ref":"APIac.html","title":"APIac","type":"module"},{"doc":"Returns true if the connection is authenticated by an APIac plug, false otherwise","ref":"APIac.html#authenticated?/1","title":"APIac.authenticated?/1","type":"function"},{"doc":"Returns the APIac.Authenticator that has authenticated the connection, nil if none has","ref":"APIac.html#authenticator/1","title":"APIac.authenticator/1","type":"function"},{"doc":"Returns the name of the client, or nil if the connection is unauthenticated","ref":"APIac.html#client/1","title":"APIac.client/1","type":"function"},{"doc":"Returns the following error response verbosity level depending on the environment: dev: :debug test: :normal prod: :normal It uses the APIac configuration key :env that is by defaults executed to Mix.env()","ref":"APIac.html#default_error_response_verbosity/1","title":"APIac.default_error_response_verbosity/1","type":"function"},{"doc":"Returns true if this is a machine-to-machine authentication (i.e. no subject involved), false otherwise","ref":"APIac.html#machine_to_machine?/1","title":"APIac.machine_to_machine?/1","type":"function"},{"doc":"Returns metadata associated with the authenticated connection, or nil if there&#39;s none","ref":"APIac.html#metadata/1","title":"APIac.metadata/1","type":"function"},{"doc":"Returns true if the input string is an rfc7230 quoted-string, false otherwise","ref":"APIac.html#rfc7230_quotedstring?/1","title":"APIac.rfc7230_quotedstring?/1","type":"function"},{"doc":"Returns true if the input string is an rfc7230 token, false otherwise","ref":"APIac.html#rfc7230_token?/1","title":"APIac.rfc7230_token?/1","type":"function"},{"doc":"Returns true if the input string is an rfc7235 token68, false otherwise","ref":"APIac.html#rfc7235_token68?/1","title":"APIac.rfc7235_token68?/1","type":"function"},{"doc":"Sets the HTTP WWW-Authenticate header of a Plug.Conn and returns it. Note that the parameters are passed as a map whose: keys are rfc7230 tokens values are rfc7230 quoted-strings, but without the enclosing quotes: they are mandatory and therefore added automatically Examples iex&gt; conn(:get, &quot;/ressource&quot;) |&gt; ...&gt; Plug.Conn.put_status(:unauthorized) |&gt; ...&gt; APIac.set_WWWauthenticate_challenge(&quot;Basic&quot;, %{&quot;realm&quot; =&gt; &quot;realm_1&quot;}) |&gt; ...&gt; APIac.set_WWWauthenticate_challenge(&quot;Bearer&quot;, %{&quot;realm&quot; =&gt; &quot;realm_1&quot;, &quot;error&quot; =&gt; &quot;insufficient_scope&quot;, &quot;scope&quot; =&gt; &quot;group:read group:write&quot;}) %Plug.Conn{ adapter: {Plug.Adapters.Test.Conn, :...}, assigns: %{}, before_send: [], body_params: %Plug.Conn.Unfetched{aspect: :body_params}, cookies: %Plug.Conn.Unfetched{aspect: :cookies}, halted: false, host: &quot;www.example.com&quot;, method: &quot;GET&quot;, owner: #PID&lt;0.202.0&gt;, params: %Plug.Conn.Unfetched{aspect: :params}, path_info: [&quot;ressource&quot;], path_params: %{}, peer: {{127, 0, 0, 1}, 111317}, port: 80, private: %{}, query_params: %Plug.Conn.Unfetched{aspect: :query_params}, query_string: &quot;&quot;, remote_ip: {127, 0, 0, 1}, req_cookies: %Plug.Conn.Unfetched{aspect: :cookies}, req_headers: [], request_path: &quot;/ressource&quot;, resp_body: nil, resp_cookies: %{}, resp_headers: [ {&quot;cache-control&quot;, &quot;max-age=0, private, must-revalidate&quot;}, {&quot;www-authenticate&quot;, &quot;Basic realm=&quot;realm_1&quot;, Bearer error=&quot;insufficient_scope&quot;, realm=&quot;realm_1&quot;, scope=&quot;group:read group:write&quot;&quot;} ], scheme: :http, script_name: [], secret_key_base: nil, state: :unset, status: 401 }","ref":"APIac.html#set_WWWauthenticate_challenge/3","title":"APIac.set_WWWauthenticate_challenge/3","type":"function"},{"doc":"Returns the name of the subject, or nil if it was not set (unauthenticated connection, machine-tomachine authentication...)","ref":"APIac.html#subject/1","title":"APIac.subject/1","type":"function"},{"doc":"Returns true if the authentication is on behalf of a real user (the subject), false otherwise","ref":"APIac.html#subject_authenticated?/1","title":"APIac.subject_authenticated?/1","type":"function"},{"doc":"","ref":"APIac.html#t:client/0","title":"APIac.client/0","type":"type"},{"doc":"","ref":"APIac.html#t:http_authn_scheme/0","title":"APIac.http_authn_scheme/0","type":"type"},{"doc":"","ref":"APIac.html#t:metadata/0","title":"APIac.metadata/0","type":"type"},{"doc":"","ref":"APIac.html#t:realm/0","title":"APIac.realm/0","type":"type"},{"doc":"","ref":"APIac.html#t:subject/0","title":"APIac.subject/0","type":"type"},{"doc":"","ref":"APIac.AuthFailureResponseData.html","title":"APIac.AuthFailureResponseData","type":"module"},{"doc":"Returns the authentication failure information from the Plug.Conn.t()","ref":"APIac.AuthFailureResponseData.html#get/1","title":"APIac.AuthFailureResponseData.get/1","type":"function"},{"doc":"Adds authentication failure information to the Plug.Conn.t() object","ref":"APIac.AuthFailureResponseData.html#put/2","title":"APIac.AuthFailureResponseData.put/2","type":"function"},{"doc":"","ref":"APIac.AuthFailureResponseData.html#t:t/0","title":"APIac.AuthFailureResponseData.t/0","type":"type"},{"doc":"Specification for authenticator plug An authenticator is in charge of extracting and validating credentials. It can also returns an error indicating how to authenticate, giving information such as authentication scheme to use, etc.","ref":"APIac.Authenticator.html","title":"APIac.Authenticator","type":"behaviour"},{"doc":"Extract the credentials from the Plug.Conn object Returns {:ok, Plug.Conn.t, credentials} if credentials were found. It is required to return the Plug.Conn object since some things can be fetched in the process (e.g. the HTTP body). The format of credentials is specific to an APIac.Authenticator Returns {:error, Plug.Conn.t, %APIac.Authenticator.Unauthorized{}} if no credentials were found or credential extraction failed (because request is malformed, parameters are non-standard, or any other reason). When, and only when credentials are not present in the request, the reason field of the %APIac.Authenticator.Unauthorized{} shall be set to the atom :credentials_not_found. The semantics are the following: if credentials were not found, the HTTP WWW-Authenticate can be set to advertise the calling client of the available authentication scheme if credentials were found but an error happens when extracting it, that is an error (since the client tried to authenticate) and the plug pipeline execution should be stopped The opts parameter is the value returned by Plug.init/1","ref":"APIac.Authenticator.html#c:extract_credentials/2","title":"APIac.Authenticator.extract_credentials/2","type":"callback"},{"doc":"Sets the HTTP error response and halts the plug Typically, the error is returned as: An error status code (e.g. &#39;401 Unauthorized&#39;) WWW-Authenticate standard HTTP header Specifically, it may set the headers, HTTP status code and HTTP body, depending on: The Elixir.APIac.Authenticator The opts[:error_response_verbosity] function Specifics are to be documented in implementation plugs The opts parameter is the value returned by Plug.init/1","ref":"APIac.Authenticator.html#c:send_error_response/3","title":"APIac.Authenticator.send_error_response/3","type":"callback"},{"doc":"Validate credentials previously extracted by extract_credentials/2 Returns {:ok, Plug.Conn.t if credentials are valid. It is required to return the Plug.Conn object since some things can be fetched in the process (e.g. the HTTP body). Returns {:error, Plug.Conn.t, %APIac.Authenticator.Unauthorized{}} if credentials are invalid The opts parameter is the value returned by Plug.init/1","ref":"APIac.Authenticator.html#c:validate_credentials/3","title":"APIac.Authenticator.validate_credentials/3","type":"callback"},{"doc":"","ref":"APIac.Authenticator.html#t:credentials/0","title":"APIac.Authenticator.credentials/0","type":"type"},{"doc":"","ref":"APIac.Authenticator.html#t:opts/0","title":"APIac.Authenticator.opts/0","type":"type"},{"doc":"Specification for filter plug A filter is a plug that allows or blocks a connection based in the connection information.","ref":"APIac.Filter.html","title":"APIac.Filter","type":"behaviour"},{"doc":"Either allows or blocks the connection Returns {:ok, Plug.Conn.t()} if the connection is allowed. Returns {:error, Plug.Conn.t(), %APIac.Filter.Forbidden{}} otherwise. The opts parameter is the value returned by Plug.init/1","ref":"APIac.Filter.html#c:filter/2","title":"APIac.Filter.filter/2","type":"callback"},{"doc":"Sets the HTTP error response and halts the plug Specifically, it may set the headers, HTTP status code and HTTP body, depending on: The Elixir.APIac.Filter The opts[:error_response_verbosity] function Specifics are to be documented in implementation plugs","ref":"APIac.Filter.html#c:send_error_response/3","title":"APIac.Filter.send_error_response/3","type":"callback"},{"doc":"","ref":"APIac.Filter.html#t:opts/0","title":"APIac.Filter.opts/0","type":"type"},{"doc":"","ref":"APIac.Authenticator.Unauthorized.html","title":"APIac.Authenticator.Unauthorized","type":"exception"},{"doc":"","ref":"APIac.Authenticator.Unauthorized.html#exception/2","title":"APIac.Authenticator.Unauthorized.exception/2","type":"function"},{"doc":"Callback implementation for Exception.message/1.","ref":"APIac.Authenticator.Unauthorized.html#message/1","title":"APIac.Authenticator.Unauthorized.message/1","type":"function"},{"doc":"","ref":"APIac.Filter.Forbidden.html","title":"APIac.Filter.Forbidden","type":"exception"},{"doc":"","ref":"APIac.Filter.Forbidden.html#exception/3","title":"APIac.Filter.Forbidden.exception/3","type":"function"},{"doc":"Callback implementation for Exception.message/1.","ref":"APIac.Filter.Forbidden.html#message/1","title":"APIac.Filter.Forbidden.message/1","type":"function"},{"doc":"APIac APIac: API access control for elixir APIac is a standard interface for API access control and is composed of: APIac.Authenticator: an Elixir behaviour for API authentication plugs APIac.Filter: an Elixir behaviour for API filter plugs Convenience functions for working with APIac plugs and for HTTP APIs The following APIac plugs are available: APIac.Authenticator: APIacAuthBasic: implementatoin of the Basic HTTP authentication scheme (RFC7617) APIacAuthBearer: implementation of the Bearer HTTP authentication scheme (RFC6750) and the OAuth 2.0 Token Introspection (RFC7662) token verification method APIacAuthMTLS: implementation of the OAuth 2.0 Mutual TLS Client Authentication and Certificate Bound Access Tokens RFC8705 APIacAuthClientJWT: implementation of the client authentication part of RFC7523 (JSON Web Token (JWT) Profile for OAuth 2.0 Client Authentication and Authorization Grants) APIacAuthClientSecretPost: implementation of the OAuth2 client secret post scheme APIac.Filter: APIacFilterIPWhitelist: IPv4 and IPv6 address whitelisting APIacFilterIPBlacklist: IPv4 and IPv6 address blacklisting APIacFilterThrottler: throttler that can throttle on IP address, client, subject, URI, etc.","ref":"readme.html","title":"APIac","type":"extras"},{"doc":"Just use one or more of these aforementioned APIac plugs, this library will be automatically imported.","ref":"readme.html#usage","title":"APIac - Usage","type":"extras"},{"doc":"APIac interfaces are designed so that you can chain APIac plugs. Example: my_app/lib/my_app_web/router.ex pipeline :api_public do plug APIacAuthBasic, realm: &quot;Public API&quot;, callback: &amp;MyApp.get_client_secret/2, set_error_response: APIacAuthBasic.set_WWWauthenticate_header/3, error_response_verbosity: :debug}, plug APIacAuthBearer, bearer_validator: {APIacAuthBearer.Validator.Introspect, [ issuer: &quot;https://example.com/auth&quot; tesla_middleware:[ {Tesla.Middleware.BasicAuth, [username: &quot;client_id_123&quot;, password: &quot;WN2P3Ci+meSLtVipc1EZhbFm2oZyMgWIx/ygQhngFbo&quot;]} ]]}, bearer_extract_methods: [:header, :body], required_scopes: [&quot;article:write&quot;, &quot;comments:moderate&quot;], forward_bearer: true, cache: {APIacAuthBearerCacheCachex, []} plug APIacFilterThrottler, key: &amp;APIacFilterThrottler.Functions.throttle_by_ip_path/1, scale: 60_000, limit: 50, exec_cond: &amp;APIac.machine_to_machine?/1, error_response_verbosity: :debug} end","ref":"readme.html#chaining-plugs","title":"APIac - Chaining plugs","type":"extras"},{"doc":"APIac uses the OAuth2 terminology: the client is the server, the machine, accessing the API the subject is the pysical user (real life person) on behalf on who the API access is performed. Note even though in most cases the subject has authenticated, but it should not be used as a proof of authentication since: this may have be a long time ago (using OAuth2 refresh_token) this may not be true at all: in case the subject is impersonnated when using UMA2 flows OAuth2 is an access control protocol, not a federated authentication protocol APIac plugs are designed for API accesses. Therefore, do not use it for end-user authentication as this may lead to security vulnerabilities. For example, the APIacAuthBasic authenticator does not handle weak user passwords and using it for browser-based authentication by end-user will result in security flaws.","ref":"readme.html#terminology","title":"APIac - Terminology","type":"extras"},{"doc":"The following table summarizes the information of the APIac authenticators: AuthenticatorMachine-to-machineAccesses of subjects (real persons) APIacAuthBasic✔ APIacAuthBearerOAuth2 client credentials flowOAuth2 authorization code, implicit and password flowsOpenID Connect flows APIacAuthMTLS✔ APIacAuthClientJWT✔ APIacAuthClientSecretPost✔ Machine-to-machine (also known as server-to-server or s2s) refers to access when only machines are involved, without subject.","ref":"readme.html#authenticators","title":"APIac - Authenticators","type":"extras"}]